gym102059K(DP->二维偏序)

题目链接

https://codeforces.com/gym/102059/problem/K

题意

给定 $n$ 个物品,对每个物品,若他是第 $c_i$ 个取走的,他将产生 $d_i$ 价值

对 $k=1..n$ ,从 $k$ 出发在任意位置向左或者向右,遇到物品立刻取走,问取完所有物品后能产生的最大价值

题解

好题

首先容易想到设 $dp[i][j]$ 为从 $[i,j]$ 出发到结束的价值,那么从大区间往小区间转移,考虑最后一个取走的数即可,然而复杂度是 $O(n^2)$ 的,不能接受

可以发现大部分转移的权值为 $0$ ,事实上非 $0$ 的转移只有 $O(n)$ 个,因此直接把这些转移拿出来,按照原来的次序做转移即可。。。两个状态显然需要满足二维偏序关系才能发生转移,因此该题又转化成一个二维偏序问题。。




代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
/**
*         ┏┓    ┏┓
*         ┏┛┗━━━━━━━┛┗━━━┓
*         ┃       ┃  
*         ┃   ━    ┃
*         ┃ >   < ┃
*         ┃       ┃
*         ┃... ⌒ ...  ┃
*         ┃ ┃
*         ┗━┓ ┏━┛
*          ┃ ┃ Code is far away from bug with the animal protecting          
*          ┃ ┃ 神兽保佑,代码无bug
*          ┃ ┃           
*          ┃ ┃       
*          ┃ ┃
*          ┃ ┃           
*          ┃ ┗━━━┓
*          ┃ ┣┓
*          ┃ ┏┛
*          ┗┓┓┏━━━━━━━━┳┓┏┛
*           ┃┫┫ ┃┫┫
*           ┗┻┛ ┗┻┛
*/

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<stack>
#include<cmath>
#include<set>
#include<bitset>
#include<assert.h>
#define inc(i,l,r) for(int i=l;i<=r;i++)
#define dec(i,l,r) for(int i=l;i>=r;i--)
#define link(x) for(edge *j=h[x];j;j=j->next)
#define mem(a) memset(a,0,sizeof(a))
#define ll long long
#define succ(x) (1<<x)
#define lowbit(x) (x&(-x))
#define sqr(x) ((x)*(x))
#define mid (x+y>>1)
#define NM 300005
#define nm 500005
#define pi 3.1415926535897931
using namespace std;
const ll inf=1e18;
const double eps=1e-8;
ll read(){
ll x=0,f=1;char ch=getchar();
while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
return f*x;
}




struct P{
int x,y;
bool operator<(const P&o)const{return y<o.y||(y==o.y&&x>o.x);}
bool operator==(const P&o)const{return x==o.x&&y==o.y;}
}a[NM<<1];
int c[NM],d[NM],tot,cnt,n;
ll tr[NM],ans[NM];
inline void add(int x,ll t){for(;x<=n;x+=lowbit(x))tr[x]=max(tr[x],t);}
inline ll sum(int x,ll s=0){for(;x;x-=lowbit(x))s=max(s,tr[x]);return s;}

int main(){
n=read();
inc(i,1,n){
c[i]=read();
if(c[i]==1)continue;
if(c[i]<=i)a[++tot].x=i-c[i]+1,a[tot].y=i;
if(i+c[i]-1<=n)a[++tot].x=i,a[tot].y=i+c[i]-1;
}
inc(i,1,n)d[i]=read();
sort(a+1,a+1+tot);
cnt=tot=unique(a+1,a+1+tot)-a-1;
dec(i,n,1){
for(;cnt&&a[cnt].y==i+1;cnt--)if(c[a[cnt].y]==a[cnt].y-a[cnt].x+1){
ll s=sum(a[cnt].x)+d[a[cnt].y];
add(a[cnt].x,s);
}
for(;tot&&a[tot].y==i;tot--)if(c[a[tot].x]==a[tot].y-a[tot].x+1){
ll s=sum(a[tot].x)+d[a[tot].x];
add(a[tot].x+1,s);
}
ans[i]=sum(i);
if(c[i]==1)ans[i]+=d[i];
}
inc(i,1,n)printf("%lld ",ans[i]);putchar('\n');
return 0;
}